using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Linq;
using Crestron;
using Crestron.Logos.SplusLibrary;
using Crestron.Logos.SplusObjects;
using Crestron.SimplSharp;

namespace UserModule_SE_1200_TAKE_BAR_PROCESSOR
{
    public class UserModuleClass_SE_1200_TAKE_BAR_PROCESSOR : SplusObject
    {
        static CCriticalSection g_criticalSection = new CCriticalSection();
        
        Crestron.Logos.SplusObjects.AnalogInput TAKEBARIN;
        Crestron.Logos.SplusObjects.AnalogOutput TAKEBAROUT_WHOLE;
        Crestron.Logos.SplusObjects.AnalogOutput TAKEBAROUT_FRACTION;
        object TAKEBARIN_OnChange_0 ( Object __EventInfo__ )
        
            { 
            Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
            try
            {
                SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
                ushort A1 = 0;
                
                
                __context__.SourceCodeLine = 180;
                A1 = (ushort) ( ((TAKEBARIN  .UshortValue * 10000) / 65535) ) ; 
                __context__.SourceCodeLine = 182;
                TAKEBAROUT_WHOLE  .Value = (ushort) ( (A1 / 100) ) ; 
                __context__.SourceCodeLine = 183;
                TAKEBAROUT_FRACTION  .Value = (ushort) ( Mod( A1 , 100 ) ) ; 
                
                
            }
            catch(Exception e) { ObjectCatchHandler(e); }
            finally { ObjectFinallyHandler( __SignalEventArg__ ); }
            return this;
            
        }
        
    
    public override void LogosSplusInitialize()
    {
        SocketInfo __socketinfo__ = new SocketInfo( 1, this );
        InitialParametersClass.ResolveHostName = __socketinfo__.ResolveHostName;
        _SplusNVRAM = new SplusNVRAM( this );
        
        TAKEBARIN = new Crestron.Logos.SplusObjects.AnalogInput( TAKEBARIN__AnalogSerialInput__, this );
        m_AnalogInputList.Add( TAKEBARIN__AnalogSerialInput__, TAKEBARIN );
        
        TAKEBAROUT_WHOLE = new Crestron.Logos.SplusObjects.AnalogOutput( TAKEBAROUT_WHOLE__AnalogSerialOutput__, this );
        m_AnalogOutputList.Add( TAKEBAROUT_WHOLE__AnalogSerialOutput__, TAKEBAROUT_WHOLE );
        
        TAKEBAROUT_FRACTION = new Crestron.Logos.SplusObjects.AnalogOutput( TAKEBAROUT_FRACTION__AnalogSerialOutput__, this );
        m_AnalogOutputList.Add( TAKEBAROUT_FRACTION__AnalogSerialOutput__, TAKEBAROUT_FRACTION );
        
        
        TAKEBARIN.OnAnalogChange.Add( new InputChangeHandlerWrapper( TAKEBARIN_OnChange_0, false ) );
        
        _SplusNVRAM.PopulateCustomAttributeList( true );
        
        NVRAM = _SplusNVRAM;
        
    }
    
    public override void LogosSimplSharpInitialize()
    {
        
        
    }
    
    public UserModuleClass_SE_1200_TAKE_BAR_PROCESSOR ( string InstanceName, string ReferenceID, Crestron.Logos.SplusObjects.CrestronStringEncoding nEncodingType ) : base( InstanceName, ReferenceID, nEncodingType ) {}
    
    
    
    
    const uint TAKEBARIN__AnalogSerialInput__ = 0;
    const uint TAKEBAROUT_WHOLE__AnalogSerialOutput__ = 0;
    const uint TAKEBAROUT_FRACTION__AnalogSerialOutput__ = 1;
    
    [SplusStructAttribute(-1, true, false)]
    public class SplusNVRAM : SplusStructureBase
    {
    
        public SplusNVRAM( SplusObject __caller__ ) : base( __caller__ ) {}
        
        
    }
    
    SplusNVRAM _SplusNVRAM = null;
    
    public class __CEvent__ : CEvent
    {
        public __CEvent__() {}
        public void Close() { base.Close(); }
        public int Reset() { return base.Reset() ? 1 : 0; }
        public int Set() { return base.Set() ? 1 : 0; }
        public int Wait( int timeOutInMs ) { return base.Wait( timeOutInMs ) ? 1 : 0; }
    }
    public class __CMutex__ : CMutex
    {
        public __CMutex__() {}
        public void Close() { base.Close(); }
        public void ReleaseMutex() { base.ReleaseMutex(); }
        public int WaitForMutex() { return base.WaitForMutex() ? 1 : 0; }
    }
     public int IsNull( object obj ){ return (obj == null) ? 1 : 0; }
}


}
