#include "TypeDefs.h"
#include "Globals.h"
#include "FnctList.h"
#include "Library.h"
#include "SimplSig.h"
#include "S2_SE_1200_Take_Bar_Processor.h"

FUNCTION_MAIN( S2_SE_1200_Take_Bar_Processor );
EVENT_HANDLER( S2_SE_1200_Take_Bar_Processor );
DEFINE_ENTRYPOINT( S2_SE_1200_Take_Bar_Processor );

DEFINE_INDEPENDENT_EVENTHANDLER( S2_SE_1200_Take_Bar_Processor, 00000 /*TakeBarIn*/ )

    {
    /* Begin local function variable declarations */
    
    unsigned short  __A1; 
    SAVE_GLOBAL_POINTERS ;
    CheckStack( INSTANCE_PTR( S2_SE_1200_Take_Bar_Processor ) );
    
    
    /* End local function variable declarations */
    
    
    UpdateSourceCodeLine( INSTANCE_PTR( S2_SE_1200_Take_Bar_Processor ), 180 );
    __A1 = DO_DIVIDE(INSTANCE_PTR( S2_SE_1200_Take_Bar_Processor ), (GetAnalogInput( INSTANCE_PTR( S2_SE_1200_Take_Bar_Processor ), __S2_SE_1200_Take_Bar_Processor_TAKEBARIN_ANALOG_INPUT ) * 10000), 65535); 
    UpdateSourceCodeLine( INSTANCE_PTR( S2_SE_1200_Take_Bar_Processor ), 182 );
    SetAnalog ( INSTANCE_PTR( S2_SE_1200_Take_Bar_Processor ), __S2_SE_1200_Take_Bar_Processor_TAKEBAROUT_WHOLE_ANALOG_OUTPUT, DO_DIVIDE(INSTANCE_PTR( S2_SE_1200_Take_Bar_Processor ), __A1, 100)) ; 
    UpdateSourceCodeLine( INSTANCE_PTR( S2_SE_1200_Take_Bar_Processor ), 183 );
    SetAnalog ( INSTANCE_PTR( S2_SE_1200_Take_Bar_Processor ), __S2_SE_1200_Take_Bar_Processor_TAKEBAROUT_FRACTION_ANALOG_OUTPUT, DO_MOD(INSTANCE_PTR( S2_SE_1200_Take_Bar_Processor ), __A1, 100)) ; 
    
    S2_SE_1200_Take_Bar_Processor_Exit__Event_0:
    /* Begin Free local function variables */
/* End Free local function variables */
RESTORE_GLOBAL_POINTERS ;

}


/********************************************************************************
  Constructor
********************************************************************************/

/********************************************************************************
  Destructor
********************************************************************************/

/********************************************************************************
  static void ProcessDigitalEvent( struct Signal_s *Signal )
********************************************************************************/
static void ProcessDigitalEvent( struct Signal_s *Signal )
{
    switch ( Signal->SignalNumber )
    {
        default :
            SetSymbolEventStart ( INSTANCE_PTR( S2_SE_1200_Take_Bar_Processor ) ); 
            break ;
        
    }
}

/********************************************************************************
  static void ProcessAnalogEvent( struct Signal_s *Signal )
********************************************************************************/
static void ProcessAnalogEvent( struct Signal_s *Signal )
{
    switch ( Signal->SignalNumber )
    {
        case __S2_SE_1200_Take_Bar_Processor_TAKEBARIN_ANALOG_INPUT :
            SAFESPAWN_EVENTHANDLER( S2_SE_1200_Take_Bar_Processor, 00000 /*TakeBarIn*/, 0 );
            break;
            
        default :
            SetSymbolEventStart ( INSTANCE_PTR( S2_SE_1200_Take_Bar_Processor ) ); 
            break ;
        
    }
}

/********************************************************************************
  static void ProcessStringEvent( struct Signal_s *Signal )
********************************************************************************/
static void ProcessStringEvent( struct Signal_s *Signal )
{
    if ( UPDATE_INPUT_STRING( S2_SE_1200_Take_Bar_Processor ) == 1 ) return ;
    
    switch ( Signal->SignalNumber )
    {
        default :
            SetSymbolEventStart ( INSTANCE_PTR( S2_SE_1200_Take_Bar_Processor ) ); 
            break ;
        
    }
}

/********************************************************************************
  static void ProcessSocketConnectEvent( struct Signal_s *Signal )
********************************************************************************/
static void ProcessSocketConnectEvent( struct Signal_s *Signal )
{
    switch ( Signal->SignalNumber )
    {
        default :
            SetSymbolEventStart ( INSTANCE_PTR( S2_SE_1200_Take_Bar_Processor ) ); 
            break ;
        
    }
}

/********************************************************************************
  static void ProcessSocketDisconnectEvent( struct Signal_s *Signal )
********************************************************************************/
static void ProcessSocketDisconnectEvent( struct Signal_s *Signal )
{
    switch ( Signal->SignalNumber )
    {
        default :
            SetSymbolEventStart ( INSTANCE_PTR( S2_SE_1200_Take_Bar_Processor ) ); 
            break ;
        
    }
}

/********************************************************************************
  static void ProcessSocketReceiveEvent( struct Signal_s *Signal )
********************************************************************************/
static void ProcessSocketReceiveEvent( struct Signal_s *Signal )
{
    if ( UPDATE_INPUT_STRING( S2_SE_1200_Take_Bar_Processor ) == 1 ) return ;
    
    switch ( Signal->SignalNumber )
    {
        default :
            SetSymbolEventStart ( INSTANCE_PTR( S2_SE_1200_Take_Bar_Processor ) ); 
            break ;
        
    }
}

/********************************************************************************
  static void ProcessSocketStatusEvent( struct Signal_s *Signal )
********************************************************************************/
static void ProcessSocketStatusEvent( struct Signal_s *Signal )
{
    switch ( Signal->SignalNumber )
    {
        default :
            SetSymbolEventStart ( INSTANCE_PTR( S2_SE_1200_Take_Bar_Processor ) ); 
            break ;
        
    }
}

/********************************************************************************
  EVENT_HANDLER( S2_SE_1200_Take_Bar_Processor )
********************************************************************************/
EVENT_HANDLER( S2_SE_1200_Take_Bar_Processor )
    {
    SAVE_GLOBAL_POINTERS ;
    switch ( Signal->Type )
        {
        case e_SIGNAL_TYPE_DIGITAL :
            ProcessDigitalEvent( Signal );
            break ;
        case e_SIGNAL_TYPE_ANALOG :
            ProcessAnalogEvent( Signal );
            break ;
        case e_SIGNAL_TYPE_STRING :
            ProcessStringEvent( Signal );
            break ;
        case e_SIGNAL_TYPE_CONNECT :
            ProcessSocketConnectEvent( Signal );
            break ;
        case e_SIGNAL_TYPE_DISCONNECT :
            ProcessSocketDisconnectEvent( Signal );
            break ;
        case e_SIGNAL_TYPE_RECEIVE :
            ProcessSocketReceiveEvent( Signal );
            break ;
        case e_SIGNAL_TYPE_STATUS :
            ProcessSocketStatusEvent( Signal );
            break ;
        }
        
    RESTORE_GLOBAL_POINTERS ;
    
    }
    
/********************************************************************************
  FUNCTION_MAIN( S2_SE_1200_Take_Bar_Processor )
********************************************************************************/
FUNCTION_MAIN( S2_SE_1200_Take_Bar_Processor )
{
    SAVE_GLOBAL_POINTERS ;
    
    SET_INSTANCE_POINTER ( S2_SE_1200_Take_Bar_Processor );
    
    
    INITIALIZE_GLOBAL_STRING_STRUCT ( S2_SE_1200_Take_Bar_Processor, sGenericOutStr, e_INPUT_TYPE_NONE, GENERIC_STRING_OUTPUT_LEN );
    
    
    
    S2_SE_1200_Take_Bar_Processor_Exit__MAIN:
    RESTORE_GLOBAL_POINTERS ;
    return 0 ;
    }
